% Método de Jacobi
% A x = b sistema de partida
% Lo escribimos como
% x = D^-1(b - (A-D) x)  [Esto es lo que se itera]
% donde D es la diagonal de A (poner a cero lo que no es diagonal). 

% En vez de definir D=diag(diag(A)) escribir D^-1, vamos a
% hallar la inversa "a mano".

N = 100; % Número de iteraciones

A = [5,2,1; -3,6,1; 2,3,5];
%A = [5,2,1; -3,1,1; 2,3,1]; % Dos de la diagonal no "dominan" (no converge)

b = [10; 6; 20];
% Solución con comando matlab A\b
% Definimos Ap = A-D
Ap = A - diag(diag(A));
% La inversa de los elementos de la diagonal es:
Dinv = diag(A).^-1;

% Valor inicial
n = size(A,1);
x = zeros(n,1);

% Iteraciones del método de Jacobi
for k = 1:N
    x = Dinv .* (b - Ap*x);
end

disp(x)

% Para que el método de Jacobi converja es suficiente es que los
% la diagonal "dominen" al resto de los de su fila
